import java.util.Calendar;
import java.util.Date;

public class DayData {
	int year; // N
	int month; // FPP
	int date; // 
	int day; // jFjO

	DayData() {
		this(System.currentTimeMillis());
	}

	DayData(long time) {
		Calendar cal = Calendar.getInstance();
		cal.setTime(new Date(time));
		year = cal.get(Calendar.YEAR);
		month = cal.get(Calendar.MONTH) + 1;
		date = cal.get(Calendar.DAY_OF_MONTH);
		day = cal.get(Calendar.DAY_OF_WEEK) - Calendar.SUNDAY;
	}

	DayData(DayData d) {
		this.year = d.year;
		this.month = d.month;
		this.date = d.date;
		this.day = d.day;
	}

	// ti߂B}CiX̏ꍇ߂
	void move(int def) {
		while (def > 0) {
			date++;
			if (date > getDaysInMonth(year, month)) {
				date = 1;
				month++;
				if (month > 12) {
					month = 1;
					year++;
				}
			}
			day = (day + 1) % 7;
			def--;
		}
		while (def < 0) {
			date--;
			if (date < 1) {
				month--;
				if (month < 1) {
					month = 12;
					year--;
				}
				date = getDaysInMonth(year, month);
			}
			day = (day + 6) % 7;
			def++;
		}
	}

	// t̔rBd̂ق傫ꍇ̓}CiXB this-d ƊoOK
	int compareTo(DayData d) {
		int prm1 = this.year * 10000 + this.month * 100 + this.date;
		int prm2 = d.year * 10000 + d.month * 100 + d.date;
		return prm1 - prm2;
	}

	// NƌǍ̓vZ
	static final int[] DAYS_IN_MONTH = { // ꂼ̌̓
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31, };

	static int getDaysInMonth(int y, int m) {
		if (m == 2 && y % 4 == 0) { // 100NɈxƂA2000NɈx͖
			return 29;
		}
		return DAYS_IN_MONTH[m - 1];
	}

	// ɕϊ
	String getMonthString() {
		return "" + year + "N" + (month / 10) + (month % 10) +"";
	}
	
	// Ɨj𕶎ɕϊ
	String getMonthDateString() {
		return month + "" + date + "(" + getKanjiOf(day) + ")";
	}

	// Ɨj𕶎ɕϊ
	String getDateString() {
		String preposition = "";
		if(date < 10){
			preposition = " ";
		}
		return preposition + date + "(" + getKanjiOf(day) + ")";
	}

	// jɕϊ
	String getKanjiOf(int day){
		switch (day){
			case 0:
				return "";
			case 1:
				return "";
			case 2:
				return "";
			case 3:
				return "";
			case 4:
				return "";
			case 5:
				return "";
			case 6:
				return "y";
			default:
				return "";
		}
		
		
	}
	
	public String getYear() {
		return Integer.toString(year);
	}
	
	public String getDate() {
		return "" + (date / 10) + (date % 10);
	}

	public String getMonth() {
		return "" + (month / 10) + (month % 10);
	}

}
