import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import java.io.*;
import javax.microedition.io.*;

public class ScheduleCanvas extends Canvas {
    private static final int D_WIDTH = Display.getWidth();

    private static final int D_HEIGHT = Display.getHeight();

    private static final int BG_COLOR = Graphics.getColorOfRGB(255, 255, 255);

    private static final int FONT_COLOR = Graphics.getColorOfRGB(0, 0, 0);

    Graphics graphics;

    Font font;

    int fontHeight;

    private static final int STATE_CALENDAR = 0;

    private static final int STATE_SELECT_START = 1;

    private static final int STATE_SELECT_END = 2;

    private static final int STATE_EDITTING = 3;

    int state = -1;

    private static final String MODE_INSERT = "insert";

    private static final String MODE_EDIT = "edit";

    private static final String MODE_DELETE = "delete";

    String mode = MODE_INSERT;

    private static final int WAIT_TIME = 300;

    int editCursor = 0;

    DayData today; // ̓tf[^

    DayData currentDay; // J[\̂Ătf[^

    ScheduleData editData;

    ScheduleData selectedSchedule;

    int selectedNum;

    boolean cursorState = false;

    private static final boolean ON_SCHEDULE = true;

    private static final boolean OFF_SCHEDULE = false;

    /**
     * RXgN^
     */
    public ScheduleCanvas() {
        font = Font.getFont(Font.SIZE_TINY);
        fontHeight = font.getHeight();
        graphics = getGraphics();
    }

    public void main() {
        initializeCalendar();
        processCalendar();
    }

    // J_[
    void initializeCalendar() {
        today = new DayData();
        currentDay = new DayData();
        editData = new ScheduleData();
        selectedSchedule = new ScheduleData();
    }

    /**
     * J_[ʂ̏
     */
    void processCalendar() {
        loadSchedule();
        Runtime.getRuntime().gc();
        clearKeyState();
        setSoftLabel(Frame.SOFT_KEY_1, "");
        setSoftLabel(Frame.SOFT_KEY_2, "I");

        for (;;) {
            state = STATE_CALENDAR;
            mode = MODE_INSERT;
            paint(graphics);
            sleep(WAIT_TIME);
            Runtime.getRuntime().gc();

            int key = getKeyState();
            int keypad = getKeypadState();
            if (key == Display.KEY_UP || (keypad & (1 << Display.KEY_UP)) > 0) {
                currentDay.move(-7);
            } else if (key == Display.KEY_DOWN
                    || (keypad & (1 << Display.KEY_DOWN)) > 0) {
                currentDay.move(7);
            } else if (key == Display.KEY_LEFT
                    || (keypad & (1 << Display.KEY_LEFT)) > 0) {
                currentDay.move(-1);
            } else if (key == Display.KEY_RIGHT
                    || (keypad & (1 << Display.KEY_RIGHT)) > 0) {
                currentDay.move(1);
            } else if (key == Display.KEY_SELECT || key == Display.KEY_SOFT1) {
                state = STATE_SELECT_START;
                processSelectStart();
                loadSchedule();
                clearKeyState();
                setSoftLabel(Frame.SOFT_KEY_1, "");
                setSoftLabel(Frame.SOFT_KEY_2, "I");
            } else if (key == Display.KEY_SOFT2) {
                IApplication.getCurrentApp().terminate();
            }
        }
    }

    /**
     * TʃXPW[ʂ̏ JnԂI
     */
    public void processSelectStart() {
        loadSchedule();
        Runtime.getRuntime().gc();
        clearKeyState();
        setSoftLabel(Frame.SOFT_KEY_1, "");
        setSoftLabel(Frame.SOFT_KEY_2, "߂");

        for (;;) {
            paint(graphics);
            sleep(WAIT_TIME);
            Runtime.getRuntime().gc();

            int key = getKeyState();
            int keypad = getKeypadState();

            if (mode == MODE_INSERT) {
                if (key == Display.KEY_UP
                        || (keypad & (1 << Display.KEY_UP)) > 0) {
                    if (cursorState == ON_SCHEDULE) {
                        cursorState = OFF_SCHEDULE;
                    }
                    currentDay.move(-1);
                } else if (key == Display.KEY_DOWN
                        || (keypad & (1 << Display.KEY_DOWN)) > 0) {
                    if (cursorState == ON_SCHEDULE) {
                        cursorState = OFF_SCHEDULE;
                    }
                    currentDay.move(1);
                } else if (key == Display.KEY_LEFT
                        || (keypad & (1 << Display.KEY_LEFT)) > 0) {
                    // JnԂ30Oɂ炷
                    if (cursorState == ON_SCHEDULE) {
                        editData.startTime = selectedSchedule.startTime;
                        cursorState = OFF_SCHEDULE;
                    }
                    editData.shiftStartTime(-1);
                } else if (key == Display.KEY_RIGHT
                        || (keypad & (1 << Display.KEY_RIGHT)) > 0) {
                    // JnԂ30ɂ炷
                    if (cursorState == ON_SCHEDULE) {
                        editData.setStartTime(selectedSchedule.endTime);
                        cursorState = OFF_SCHEDULE;
                    } else {
                        editData.shiftStartTime(1);
                    }
                } else if (key == Display.KEY_SELECT
                        || key == Display.KEY_SOFT1) {
                    if (cursorState == ON_SCHEDULE) { // \肪ҏW
                        mode = MODE_EDIT;
                        editData = selectedSchedule;
                        processSelectStart();
                    } else { // JnԂ肵ďIԂvZ
                        if (editData.startTime == 2230) {
                            editData.setEndTime(editData.startTime + 70);
                        } else if (isInside(editData.startTime + 70)) {
                            if (editData.startTime % 100 == 0) {
                                editData.setEndTime(editData.startTime + 30);
                            } else {
                                editData.setEndTime(editData.startTime + 70);
                            }
                        } else {
                            editData.setEndTime(editData.startTime + 100);
                        }
                        mode = MODE_INSERT;
                        state = STATE_SELECT_END;
                        processSelectEnd();
                    }

                    clearKeyState();
                    setSoftLabel(Frame.SOFT_KEY_1, "");
                    setSoftLabel(Frame.SOFT_KEY_2, "߂");
                    
                    mode = MODE_INSERT;
                    state = STATE_SELECT_START;
                    cursorState = OFF_SCHEDULE;
                    
                    loadSchedule();
                    int currentTime = editData.startTime;
                    editData = new ScheduleData();
                    editData.startTime = currentTime;
                }

            } else if (mode == MODE_EDIT) {
                clearKeyState();
                setSoftLabel(Frame.SOFT_KEY_1, "폜");
                setSoftLabel(Frame.SOFT_KEY_2, "߂");

                if (key == Display.KEY_LEFT
                        || (keypad & (1 << Display.KEY_LEFT)) > 0) {
                    // JnԂ30Oɂ炷
                    if (cursorState == ON_SCHEDULE) {
                        cursorState = OFF_SCHEDULE;
                    }
       
                    editData.shiftStartTime(-1);
                    while (isInside(editData.startTime)) {
                        editData.shiftStartTime(-1);
                    }
                    
                } else if (key == Display.KEY_RIGHT
                        || (keypad & (1 << Display.KEY_RIGHT)) > 0) {
                    // JnԂ30ɂ炷
                    if (cursorState == ON_SCHEDULE) {
                        cursorState = OFF_SCHEDULE;
                    }
                    editData.shiftStartTime(1);
                    while (isInside(editData.startTime)) {
                        editData.shiftStartTime(1);
                    }
                    
                } else if (key == Display.KEY_SELECT) {
                    if (editData.startTime == 2230) {
                        editData.setEndTime(editData.startTime + 70);
                    } else if (isInside(editData.startTime + 70)) {
                        if (editData.startTime % 100 == 0) {
                            editData.setEndTime(editData.startTime + 30);
                        } else {
                            editData.setEndTime(editData.startTime + 70);
                        }
                    } else {
                        editData.setEndTime(editData.startTime + 100);
                    }

                    state = STATE_SELECT_END;
                    processSelectEnd();
                    
                    return;
                } else if (key == Display.KEY_SOFT1) {
                    mode = MODE_DELETE;
                    addScheduleData(editData);

                    return;
                }
            }

            if (key == Display.KEY_SOFT2 || key == Display.KEY_CLEAR) {
                return;
            }
        }
    }

    /**
     * IԂI
     */
    public void processSelectEnd() {
        loadSchedule();
        Runtime.getRuntime().gc();

        for (;;) {
            paint(graphics);
            sleep(WAIT_TIME);
            Runtime.getRuntime().gc();

            int key = getKeyState();
            int keypad = getKeypadState();
            if (key == Display.KEY_LEFT
                    || (keypad & (1 << Display.KEY_LEFT)) > 0) {
                // IԂ30Oɂ炷
                editData.shiftEndTime(-1);
            } else if (key == Display.KEY_RIGHT
                    || (keypad & (1 << Display.KEY_RIGHT)) > 0) {
                // IԂ30ɂ炷
                if (!isInside(editData.endTime)) {
                    editData.shiftEndTime(1);
                }
            } else if (key == Display.KEY_SOFT1 && mode == MODE_EDIT) {
                mode = MODE_DELETE;
                addScheduleData(editData);

                return;
            } else if (key == Display.KEY_SELECT || key == Display.KEY_SOFT1) {
                // IԂ肷
                state = STATE_EDITTING;
                processEdit();
                return;
            } else if (key == Display.KEY_SOFT2 || key == Display.KEY_CLEAR) {
                return;
            }
        }
    }

    /**
     * yz̗\񎞊Ԃ͈͓̔肷
     * 
     * @return
     */
    public boolean isInside(int time) {
        boolean flag = false;
        for (int i = 0; i < schedule.length; i++) {
            if (currentDay.compareTo(schedule[i].date) == 0
                    && time >= schedule[i].startTime
                    && time < schedule[i].endTime
                    && schedule[i].id != editData.id) {
                flag = true;
            }
        }
        return flag;
    }

    /**
     * XPW[ҏWʂ̏
     */
    public void processEdit() {
        editCursor = 0;

        if (mode == MODE_INSERT) {
            editData.date = currentDay;
        }

        for (;;) {
            paint(graphics);
            sleep(WAIT_TIME);
            Runtime.getRuntime().gc();

            int key = getKeyState();

            if (key == Display.KEY_UP) {
                if (editCursor > 0) {
                    editCursor--;
                }
            } else if (key == Display.KEY_DOWN) {
                if (mode == MODE_INSERT) {
                    if (editCursor < 1) {
                        editCursor++;
                    }
                } else {
                    if (editCursor < 2) {
                        editCursor++;
                    }
                }
            } else if (key == Display.KEY_SOFT1 && mode == MODE_EDIT) {
                mode = MODE_DELETE;
                addScheduleData(editData);

                return;
            } else if (key == Display.KEY_SELECT || key == Display.KEY_SOFT1) {
                try {
                    if (editCursor == 0) {
                        String title = inputString(editData.title, TextBox.KANA);
                        if (title.length() <= 6) {
                            editData.title = title;
                        }
                    } else if (editCursor == 1) {

                        addScheduleData(editData);
                        state = STATE_SELECT_START;
                        return;

                    } else if (editCursor == 2) {
                        mode = MODE_DELETE;
                        addScheduleData(editData);
                        state = STATE_SELECT_START;
                        return;
                    }
                } catch (Exception e) {
                }
            } else if (key == Display.KEY_SOFT2 || key == Display.KEY_CLEAR) {
                return;
            }

        }
    }

    /**
     * XPW[o^
     * 
     * @param editData
     */
    public void addScheduleData(ScheduleData editData) {
        // T[oɃf[^𑗐M
        int response = sendScheduleData(editData);
        if (mode == MODE_INSERT) {
            editData.id = response;
        }
        // f[^ۑ
        if (response != 0) {
            saveScheduleData(editData);
        }
    }

    /**
     * T[oɃf[^𑗐M
     * 
     * @param editData
     */
    public int sendScheduleData(ScheduleData editData) {
        HttpConnection con = null;
        InputStream inStream = null;
        String w_remsg = "0";

        // f[^𑗐MT[o
        String url = new String(IApplication.getCurrentApp().getSourceURL()
                + "release/update.php");
        url += "?mode=" + mode;

        if (mode != MODE_DELETE) {
            url += "&year=" + editData.date.year + "&month="
                    + editData.date.month + "&date=" + editData.date.date
                    + "&start=" + editData.startTime + "&finish="
                    + editData.endTime;
        }
        if (mode != MODE_INSERT) {
            url += "&id=" + editData.id;
        }

        try {
            // ڑݒ
            con = (HttpConnection) Connector.open(url, Connector.READ, true);

            // v\bhƃRec^Cvݒ
            con.setRequestMethod(HttpConnection.GET);

            // ۂɐڑ
            con.connect();

            if (con.getResponseCode() == HttpConnection.HTTP_OK) {
                // ̓Xg[擾
                inStream = con.openInputStream();
                // InputStreamReaderCX^X쐬
                // SJISUnicodeɕϊ
                InputStreamReader wi_buffer = new InputStreamReader(inStream);
                // StringBufferCX^X쐬
                StringBuffer w_StringBuffer = new StringBuffer();
                // CGI瑗MꂽXg[ǎ

                int w_char;
                while ((w_char = wi_buffer.read()) != -1) {
                    w_StringBuffer.append((char) w_char);
                }
                w_remsg = (String) w_StringBuffer.toString();

                // ̓Xg[N[Y
                inStream.close();
            }

            // ڑN[Y
            con.close();

        }
        // O
        catch (Throwable e) {
            e.printStackTrace();
        }
        return Integer.parseInt(w_remsg);
    }

    /**
     * `悷
     */
    public void paint(Graphics graphics) {
        if (state == -1) { // NpaintĂ΂Ăvɂ
            return;
        }
        graphics.lock();
        graphics.setFont(font);

        if (state == STATE_CALENDAR) {
            drawCalendar();
        } else if (state == STATE_SELECT_START || state == STATE_SELECT_END) {
            drawWeekSchedule();
        } else if (state == STATE_EDITTING) {
            drawEdit();
        }

        graphics.unlock(true);
    }

    /**
     * J_[ʂ`
     */
    void drawCalendar() {
        graphics.setColor(BG_COLOR);
        graphics.fillRect(0, 0, D_WIDTH, D_HEIGHT);

        graphics.setColor(FONT_COLOR);
        graphics.drawString(currentDay.getMonthString(), 5, fontHeight + 5);

        // n߂tvZ
        DayData dat = new DayData(currentDay);
        // QTԑO̓jɖ߂
        dat.move(-14);
        dat.move(-dat.day);

        // `Jn
        int dayW = fontHeight + 6;
        int dayH = fontHeight + 3;
        int sx = (D_WIDTH - dayW * 7) / 2;
        int sy = fontHeight + 15;

        // UTԕ\
        for (int i = 0; i < 42; i++) {
            int dx = sx + (i % 7) * dayW;
            int dy = sy + (i / 7) * dayH;
            if (i == 0 || dat.date == 1) {
                graphics.setColor(Graphics.getColorOfRGB(230, 230, 255));
                if (dat.month % 2 == 0) {
                    graphics.setColor(Graphics.getColorOfRGB(255, 230, 230));
                }
                graphics.fillRect(dx, dy, dayW * (7 - dat.day), dayH);
                if (i < 35) {
                    graphics.fillRect(sx, dy + dayH, dayW * 7, dayH
                            * (5 - i / 7));
                }
            }

            // ̓t͐Fς
            if (dat.date == today.date && dat.month == today.month) {
                graphics.setColor(Graphics.getColorOfRGB(255, 255, 0));
                graphics.fillRect(dx, dy, dayW, dayH);
            }

            // jƓyj͐Fς
            if (dat.day == 0) {
                graphics.setColor(Graphics.getColorOfRGB(255, 0, 0));
            } else if (dat.day == 6) {
                graphics.setColor(Graphics.getColorOfRGB(0, 0, 255));
            } else {
                graphics.setColor(Graphics.getColorOfRGB(0, 0, 0));
            }
            String str = "" + (dat.date / 10) + (dat.date % 10);
            graphics.drawString(str, dx + 2, dy + 2 + fontHeight);

            // I̗\ꂽɂɉ`
            for (int k = 0; k < allDaySchedules.length; k++) {
                if (dat.compareTo(allDaySchedules[k]) == 0) {
                    graphics.drawLine(dx + 2, dy + 2 + fontHeight / 2, dx
                            + fontHeight, dy + 2 + fontHeight / 2);
                    break;
                }
            }

            // I𒆂̓ɘg`
            if (dat.date == currentDay.date && dat.month == currentDay.month) {
                graphics.setColor(Graphics.getColorOfRGB(0, 200, 0));
                graphics.drawRect(dx, dy, dayW - 1, dayH - 1);
                graphics.drawRect(dx + 1, dy + 1, dayW - 3, dayH - 3);
            }
            dat.move(1);
        }

        int x = 1;
        int y = 120;
        // XPW[\`
        drawTable(x, y);
    }

    /**
     * TʃXPW[ʂ`
     */
    public void drawWeekSchedule() {
        graphics.setColor(BG_COLOR);
        graphics.fillRect(0, 0, D_WIDTH, D_HEIGHT);

        graphics.setColor(FONT_COLOR);
        graphics.drawString(currentDay.getMonthString(), 5, 5 + fontHeight);

        graphics.setColor(Graphics.getColorOfName(Graphics.BLUE));
        if (state == STATE_SELECT_START) {
            if (mode == MODE_INSERT) {
                graphics.drawString("JnԂIĂ", 76, 5 + fontHeight);
            } else if (mode == MODE_EDIT) {
                graphics.drawString("JnԂύXĂ", 76, 5 + fontHeight);
            }
        } else if (state == STATE_SELECT_END) {
            if (mode == MODE_INSERT) {
                graphics.drawString("IԂIĂ", 76, 5 + fontHeight);
            } else if (mode == MODE_EDIT) {
                graphics.drawString("IԂύXĂ", 76, 5 + fontHeight);
            }
        }

        int x = 1;
        int y = 20;

        // XPW[\`
        drawTable(x, y);

        x = 10;
        y += 118;
        // ̃XPW[Xg`
        drawDaySchedule(x, y);
    }

    /**
     * ̃XPW[Xg`
     * 
     */
    public void drawDaySchedule(int x, int y) {
        // t
        graphics.setColor(Graphics.getColorOfName(Graphics.BLACK));
        if (currentDay.day == 0) {
            graphics.setColor(Graphics.getColorOfName(Graphics.RED));
        } else if (currentDay.day == 6) {
            graphics.setColor(Graphics.getColorOfName(Graphics.BLUE));
        }
        graphics.drawString(currentDay.getMonthDateString(), x, y);

        // Ԃ
        if (cursorState == ON_SCHEDULE) {
            graphics.drawString(selectedSchedule.getStartHour() + ":"
                    + selectedSchedule.getStartMinute() + " - "
                    + selectedSchedule.getEndHour() + ":"
                    + selectedSchedule.getEndMinute() + "  "
                    + selectedSchedule.title, x + 60, y);
        } else {
            graphics.drawString(editData.getStartHour() + ":"
                    + editData.getStartMinute() + " - ", x + 60, y);
            if (state == STATE_SELECT_END) {
                graphics.drawString(editData.getEndHour() + ":"
                        + editData.getEndMinute(), x + 108, y);
            }
        }

        x = 5;
        y += fontHeight + 2;

        int numSchedule = 0;
        int column = 1;
        for (int i = 0; i < schedule.length; i++) {
            if (schedule[i].date.compareTo(currentDay) == 0) {
                if ((cursorState == ON_SCHEDULE && selectedSchedule == schedule[i])
                        || (mode == MODE_EDIT && editData.id == schedule[i].id)) {
                    graphics.setColor(Graphics.getColorOfName(Graphics.RED));
                } else {
                    graphics.setColor(Graphics.getColorOfName(Graphics.BLACK));
                }
                graphics.drawString(schedule[i].getScheduleString(), x, y
                        + fontHeight * numSchedule);
                numSchedule++;

                // ̃f[^8z2ɕ\(PVȏ͕\łȂ)
                if (numSchedule >= 8 && column == 1) {
                    drawVerticalDottedLine(D_WIDTH / 2 - 2, D_HEIGHT / 2 + 20,
                            D_WIDTH / 2 - 2, D_HEIGHT);
                    x = D_WIDTH / 2 + 5;
                    numSchedule = 0;
                    column = 2;
                }
            }
        }
    }

    /**
     * TԃXPW[`
     * 
     * @param x
     * @param y
     */
    public void drawTable(int x, int y) {
        // XPW[\̘g`
        drawTableLine(x, y);
        // XPW[\̓t`
        drawTableDate(x, y);
        // XPW[\ɗ\̎Ԃ_Ƃĕ`
        drawTableGraph(x, y);

        // XPW[\ɑIgAJ[`
        int dayH = fontHeight + 1;
        x += 38;
        y += fontHeight;
        int currentH = dayH * currentDay.day;

        if (state == STATE_CALENDAR) {
            // Iꂽɘg`
            graphics.setColor(Graphics.getColorOfRGB(0, 200, 0));
            graphics.drawRect(x, y + currentH, 196, dayH);
            graphics.drawRect(x - 1, y + currentH - 1, 196 + 2, dayH + 2);

        } else if ((state >= STATE_SELECT_START && cursorState != ON_SCHEDULE)
                || mode == MODE_EDIT) {
            // y`
            int startW = position(editData.startTime);
            graphics.setColor(Graphics.getColorOfRGB(0, 230, 0));
            graphics.fillRect(x + startW - 1, y + currentH - 2, 3, 14);
            graphics.fillRect(x + startW - 2, y + currentH - 2, 10, 4);
            graphics.fillRect(x + startW - 2, y + currentH + 11, 10, 4);

            if (state >= STATE_SELECT_END) {
                // z`
                int endW = position(editData.endTime);
                graphics.setColor(Graphics.getColorOfRGB(0, 230, 0));
                graphics.fillRect(x + endW - 1, y + currentH - 2, 3, 14);
                graphics.fillRect(x + endW - 7, y + currentH - 2, 10, 4);
                graphics.fillRect(x + endW - 7, y + currentH + 11, 10, 4);

                // yz̊Ԃɖ_
                if (startW < endW) {
                    graphics.setColor(Graphics.getColorOfRGB(190, 190, 190));
                    int timeW = position(editData.endTime)
                            - position(editData.startTime);
                    graphics.fillRect(x + startW, y + currentH + 4, timeW, 6);
                }
            }
        }
    }

    /**
     * \ɂĂ̎Ԃ̈ʒuvZ
     */
    public int position(int time) {
        int x, distance;
        int halfWidth = (fontHeight + 2) / 2;

        x = time - 900;
        distance = (x / 100 * 2);
        if (x % 100 != 0) {
            distance++;
        }

        return distance * halfWidth;
    }

    /**
     * XPW[\` FPԁP4hbg cF14hbg(fontHeight+2)
     */
    public void drawTableLine(int baseX, int baseY) {
        graphics.setColor(FONT_COLOR);
        graphics.drawString("9", baseX + 36, baseY + 9);
        graphics.drawString("12", baseX + 76, baseY + 9);
        graphics.drawString("15", baseX + 118, baseY + 9);
        graphics.drawString("18", baseX + 160, baseY + 9);
        graphics.drawString("21", baseX + 202, baseY + 9);
        graphics.drawString("23", baseX + 228, baseY + 9);

        int originX = baseX + 38;
        int originY = baseY + fontHeight;
        int hourW = 14;
        int dayH = fontHeight + 1;

        // 
        for (int i = 0; i < 8; i++) {
            int height = i * dayH;
            graphics.drawLine(originX, originY + height, originX + 196, originY
                    + height);
        }

        // Pԋ؂̐`
        for (int i = 0; i < 15; i++) {
            int width = i * hourW;
            graphics.drawLine(originX + width, originY - 2, originX + width,
                    originY + dayH * 7);
        }

        // 30؂̐`
        for (int i = 0; i < 15; i++) {
            int width = i * hourW;
            drawVerticalDottedLine(originX + width + hourW / 2, originY,
                    originX + width + hourW / 2, originY + dayH * 7);
        }
    }

    /**
     * ɂƗj`
     */
    public void drawTableDate(int x, int y) {
        // n߂tvZ
        DayData dat = new DayData(currentDay);
        // jɖ߂
        dat.move(-dat.day);

        y += fontHeight;
        // j`
        graphics.setColor(Graphics.getColorOfName(Graphics.RED));
        graphics.drawString(dat.getDateString(), x, y + fontHeight);
        dat.move(1);
        y += fontHeight + 1;

        // `
        graphics.setColor(Graphics.getColorOfName(Graphics.BLACK));
        for (int i = 0; i < 5; i++) {
            graphics.drawString(dat.getDateString(), x, y + fontHeight);
            dat.move(1);
            y += fontHeight + 1;
        }

        // yj`
        graphics.setColor(Graphics.getColorOfName(Graphics.BLUE));
        graphics.drawString(dat.getDateString(), x, y + fontHeight);
    }

    /**
     * _`
     */
    private void drawTableGraph(int x, int y) {
        int originX = x + 38;
        int originY = y + fontHeight;

        // XPW[̎Ԃ\_`
        graphics.setColor(Graphics.getColorOfName(Graphics.BLUE));

        // n߂tAItvZ
        DayData startDate = new DayData(currentDay);
        DayData endDate = new DayData(currentDay);
        startDate.move(-startDate.day);
        endDate.move(6 - endDate.day);

        for (int i = 0; i < schedule.length; i++) {
            if (schedule[i].date.compareTo(startDate) >= 0
                    && schedule[i].date.compareTo(endDate) <= 0) {
                int startW = position(schedule[i].startTime);
                int timeW = position(schedule[i].endTime)
                        - position(schedule[i].startTime);

                if (mode == MODE_EDIT && schedule[i].id == editData.id) {
                    graphics.setColor(Graphics.getColorOfName(Graphics.RED));
                } else {
                    graphics.setColor(Graphics.getColorOfName(Graphics.BLUE));
                }
                graphics.fillRect(originX + startW, originY + 4 + 13
                        * schedule[i].date.day, timeW, 6);

                // I𒆂̗\ɘg`
                if (state >= STATE_SELECT_START
                        && currentDay.compareTo(schedule[i].date) == 0
                        && editData.startTime >= schedule[i].startTime
                        && editData.startTime < schedule[i].endTime) {
                    graphics.setColor(Graphics.getColorOfRGB(0, 230, 0));
                    graphics.drawRect(originX + startW, originY + 13
                            * schedule[i].date.day, timeW, 14);
                    graphics.drawRect(originX + startW - 1, originY - 1 + 13
                            * schedule[i].date.day, timeW, 14);
                    selectedSchedule = schedule[i];
                    selectedNum = i;
                    // if (state < STATE_EDITTING && schedule[i].id !=
                    // editData.id) {
                    cursorState = ON_SCHEDULE;
                    // }
                }
            }
        }
    }

    /**
     * XPW[ҏWʂ`
     */
    public void drawEdit() {
        graphics.setColor(BG_COLOR);
        graphics.fillRect(0, 0, D_WIDTH, D_HEIGHT);

        graphics.setColor(FONT_COLOR);
        graphics.drawString(currentDay.getMonthString(), 5, 5 + fontHeight);

        graphics.setColor(Graphics.getColorOfName(Graphics.BLUE));
        graphics.drawString("O͂Ă", 76, 5 + fontHeight);

        int x = 1;
        int y = 20;

        // XPW[\̘g`
        drawTable(x, y);

        x += 9;
        y += 125;
        graphics.setColor(FONT_COLOR);
        // t`悷
        graphics.drawString(currentDay.getMonthDateString(), x, y);
        graphics.drawString(editData.getStartHour() + ":"
                + editData.getStartMinute() + " - " + editData.getEndHour()
                + ":" + editData.getEndMinute(), x + 70, y);

        // \̖O̓̓tH[`悷
        int c = 12;
        y += 3;
        graphics.setColor(FONT_COLOR);
        graphics.drawString("O", x, y + fontHeight + 3);
        x += fontHeight * 2 + 3;
        drawBox(editData.title, x, y, c, 1, editCursor == 0);

        y += fontHeight + 8;
        x = 10;
        if (mode == MODE_INSERT) {
            drawButton("o^", x, y, editCursor == 1);
            return;
        } else {
            String str = "ύX";
            drawButton(str, x, y, editCursor == 1);
            x += (str.length() + 1) * fontHeight;
            drawButton("폜", x, y, editCursor == 2);
        }
    }

    /**
     * eLXgtH[`
     */
    void drawBox(String str, int x, int y, int col, int row, boolean focus) {
        int w = col * fontHeight / 2 + 6;
        int h = row * (fontHeight + 1) + 3;

        if (focus) {
            graphics.setColor(Graphics.getColorOfRGB(255, 0, 0));
        } else {
            graphics.setColor(Graphics.getColorOfRGB(0, 0, 0));
        }
        graphics.drawLine(x, y + 1, x, y + h - 1);
        graphics.drawLine(x + w, y + 1, x + w, y + h - 1);
        graphics.drawLine(x + 1, y, x + w - 1, y);
        graphics.drawLine(x + 1, y + h, x + w - 1, y + h);

        graphics.setColor(Graphics.getColorOfRGB(0, 0, 0));

        int sy = y + fontHeight + 3;
        int idx = 0;
        while (sy < y + h && idx < str.length()) {
            int idx2 = font.getLineBreak(str, 0, str.length(), w - 6);
            int idx3 = str.indexOf('\n', idx);
            if (idx3 >= 0 && idx3 < idx2) {
                idx2 = idx3 + 1;
            }
            graphics.drawString(str.substring(idx, idx2), x + 3, sy);
            sy += fontHeight + 1;
            idx = idx2;
        }
    }

    /**
     * {^`
     */
    void drawButton(String str, int x, int y, boolean focus) {
        if (focus) {
            graphics.setColor(Graphics.getColorOfRGB(255, 0, 0));
        } else {
            graphics.setColor(Graphics.getColorOfRGB(0, 0, 0));
        }

        int width = str.length() * fontHeight;
        graphics.drawRect(x, y, width + 4, fontHeight + 4);
        graphics.drawString(str, x + 3, y + 2 + fontHeight);
    }

    /**
     * c̓_`
     * 
     * @param x1
     * @param y1
     * @param x2
     * @param y2
     */
    public void drawVerticalDottedLine(int x1, int y1, int x2, int y2) {
        graphics.setColor(Graphics.getColorOfName(Graphics.GRAY));
        for (int i = 0; i < y2 - y1; i += 4) {
            int j = i + 2;
            graphics.drawLine(x1, y1 + i, x2, y1 + j);
        }
    }

    /***************************************************************************
     * XNb`pbh
     **************************************************************************/

    private static final int SP_SCHEDULE_DATA = 0;

    private static final int SP_SCHEDULE_DATA_LENGTH = 102400;

    ScheduleData[] schedule;

    DayData[] allDaySchedules;

    /**
     * f[^ǂݍ
     * 
     */
    void loadSchedule() {
        int counter = 0;
        try {
            ByteArrayInputStream is = new ByteArrayInputStream(load(
                    SP_SCHEDULE_DATA, SP_SCHEDULE_DATA_LENGTH));
            int num = (is.read() << 8) | is.read();
            schedule = new ScheduleData[num];
            for (int i = 0; i < schedule.length; i++) {
                schedule[i] = ScheduleData.read(is);
                if (schedule[i].isAlldaySchedule()) {
                    counter++;
                }
            }
            is.close();
        } catch (Throwable e) {
            System.out.println("" + e);
        }

        // \肪Ă𒊏o
        allDaySchedules = new DayData[counter];

        int k = 0;
        for (int i = 0; i < schedule.length; i++) {
            if (schedule[i].isAlldaySchedule()) {
                allDaySchedules[k] = schedule[i].date;
                k++;
            }
        }

    }

    /**
     * f[^ۑ
     * 
     * @param string
     */
    public boolean saveScheduleData(ScheduleData data) {
        deleteScheduleData(data.id);

        // 1ȏÕf[^
        int counter = 0;
        for (int i = 0; i < schedule.length; i++) {
            if (today.month == 1 && today.compareTo(schedule[i].date) > 8900) {
                counter++;
            } else if (today.compareTo(schedule[i].date) > 100) {
                counter++;
            } else {
                break;
            }
        }
        ScheduleData[] temp = schedule;
        schedule = new ScheduleData[temp.length - counter];
        for (int i = 0; i < schedule.length; i++) {
            schedule[i] = temp[counter + i];
        }

        if (mode != MODE_DELETE) {
            ScheduleData[] dummy = schedule;
            schedule = new ScheduleData[dummy.length + 1];
            int n = 0;
            boolean added = false;
            for (int i = 0; i < dummy.length; i++) {
                if (!added) {
                    int def = dummy[i].date.compareTo(data.date);
                    if (def > 0 || def == 0
                            && dummy[i].startTime > data.startTime) {
                        schedule[n++] = data;
                        added = true;
                    }
                }
                schedule[n++] = dummy[i];
            }
            if (!added) {// ǂ̃f[^Ԃ傫ꍇ͂
                schedule[n++] = data;
            }
        }

        return saveToScratchpad();
    }

    // XPW[f[^̍폜
    void deleteScheduleData(int id) {
        int idx = -1;
        for (int i = 0; i < schedule.length; i++) {
            if (schedule[i].id == id) {
                idx = i;
                break;
            }
        }
        if (idx < 0) {
            return;
        }

        ScheduleData[] dummy = schedule;
        schedule = new ScheduleData[dummy.length - 1];
        int n = 0;
        for (int i = 0; i < dummy.length; i++) {
            if (i != idx) {
                schedule[n++] = dummy[i];
            }
        }
    }

    boolean saveToScratchpad() {
        try {
            boolean isSavable = false;
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            while (isSavable == false) {
                os.reset();
                os.write(schedule.length >> 8);
                os.write(schedule.length);
                for (int i = 0; i < schedule.length; i++) {
                    schedule[i].write(os);
                }

                if (os.toByteArray().length > SP_SCHEDULE_DATA_LENGTH) {
                    // f[^XNb`pbh̗eʂ𒴂Âf[^
                    deleteScheduleData(schedule[0].id);
                } else {
                    isSavable = true;
                }
            }

            byte[] b = os.toByteArray();
            os.close();

            if (b.length > SP_SCHEDULE_DATA_LENGTH) {
                return false;
            }

            save(b, SP_SCHEDULE_DATA);
        } catch (Throwable e) {
        }
        return false;
    }

    // XNb`pbhւ̏
    void save(byte[] dat, int pos) {
        OutputStream os = null;
        try {
            os = Connector.openOutputStream("scratchpad:///0;pos=" + pos);
            os.write(dat);
        } catch (Throwable e) {
        }
        try {
            os.close();
        } catch (Throwable e) {
        }
    }

    // XNb`pbh̓ǂݍ
    byte[] load(int pos, int len) {
        InputStream is = null;
        byte[] ret = new byte[len];
        try {
            is = Connector.openInputStream("scratchpad:///0;pos=" + pos);
            is.read(ret);
        } catch (Throwable e) {
            ret = null;
        }
        try {
            is.close();
        } catch (Throwable e) {
        }
        return ret;
    }

    /** ************************************************************************ */

    // Cxg**************************************************
    int keyParam = -1;

    public void processEvent(int type, int param) {
        if (type == Display.KEY_PRESSED_EVENT) {
            keyParam = param;
        }
    }

    // L[Ԃ̎擾
    int getKeyState() {
        int ret = keyParam;
        keyParam = -1;
        return ret;
    }

    // L[Ԃ̃NA
    void clearKeyState() {
        keyParam = -1;
    }

    // ̑***********************************************
    void sleep(int time) {
        try {
            Thread.sleep(time);
        } catch (Throwable e) {
        }
    }

    boolean waitIME = false;

    String imeString = null;

    /**
     * ͂ꂽ擾
     * 
     * @param str
     * @param mode
     * @return
     */
    String inputString(String str, int mode) {
        while (getKeypadState() > 0) {
            sleep(100);
        }

        waitIME = true;
        imeOn(str, TextBox.DISPLAY_ANY, mode);

        while (waitIME) {
            sleep(100);
        }

        while (getKeypadState() > 0) {
            sleep(100);
        }
        return imeString;
    }

    public void processIMEEvent(int type, String str) {
        imeString = str;
        waitIME = false;
    }

}
