import java.io.InputStream;
import java.io.OutputStream;

public class ScheduleData {
	int id;
	DayData date;		//t
	int startTime, endTime;		//JnAIBHHMMƓ
	String title;		//^Cg
	boolean profile;    //\̓e
    
    //萔
    static final boolean RESERVE = true;    //\
    static final boolean PLAN = false;  //p
    
	//RXgN^
	ScheduleData() {
		date = new DayData();
		startTime = 900;
		endTime = 1000;
		title = "";
        profile = RESERVE;
	}
	
	//f[^̏
	void write(OutputStream os) throws Exception {
		os.write(date.year >> 8);
		os.write(date.year);
		os.write(date.month);
		os.write(date.date);
		os.write(date.day);
		
		os.write(startTime >> 8);
		os.write(startTime);
		os.write(endTime >> 8);
		os.write(endTime);
        
        if(profile){
            os.write(1);
        }else{
            os.write(0);
        }
		
		os.write(id >> 24);
		os.write(id >> 16);
		os.write(id >> 8);
		os.write(id);
		
		byte[] b = title.getBytes();
		os.write(b.length >> 8);
		os.write(b.length);
		os.write(b);
	}
	
	//f[^̓ǂݍ
	static ScheduleData read(InputStream is) throws Exception {
		ScheduleData sd = new ScheduleData();
		sd.date.year = (is.read() << 8) | is.read();
		sd.date.month = is.read();
		sd.date.date = is.read();
		sd.date.day = is.read();
		
		sd.startTime = (is.read() << 8) | is.read();
		sd.endTime = (is.read() << 8) | is.read();
        
        if(is.read() == 1){
            sd.profile = true;
        }else{
            sd.profile = false;
        }
		
		sd.id = (is.read() << 24) | (is.read() << 16) | (is.read() << 8) | is.read();
		
		
		int len = (is.read() << 8) | is.read();
		byte[] b = new byte[len];
		is.read(b);
		sd.title = new String(b);
		
		return sd;
	}
	
	public String getScheduleString(){
		return getStartHour() + ":" + getStartMinute() + " " + title;
	}
    
    //JnԂύX
    public void shiftStartTime(int i){
        if(i > 0){  //₷
            if(startTime >= 2230){
                startTime = 900;
            }else if(startTime % 100 > 0){    //30
                //xx:00ɂ
                startTime = (startTime / 100) * 100;
                //1ԑ
                startTime += 100;
            }else if(startTime % 100 == 0){ //0
                //30
                startTime += 30;
            }
        }else if(i < 0){    //炷
            if(startTime == 900){
                startTime = 2230;
            }else if(startTime % 100 > 0){    //30
                //xx:00ɂ
                startTime = (startTime / 100) * 100;
            }else if(startTime % 100 == 0){ //0
                //30
                startTime += 30;
                //1Ԍ炷
                startTime -= 100;
            }
        }
    }
    
    //IԂύX
    public void shiftEndTime(int i){
        if(i > 0){  //₷
            if(endTime < 2300){   
                if(endTime % 100 > 0){    //30
                    //xx:00ɂ
                    endTime = (endTime / 100) * 100;
                    //1ԑ
                    endTime += 100;
                }else if(endTime % 100 == 0){ //0
                    //30
                    endTime += 30;
                }
            }
        }else if(i < 0){    //炷
            if(endTime > startTime + 70){ 
                if(endTime % 100 > 0){    //30
                    //xx:00ɂ
                    endTime = (endTime / 100) * 100;
                }else if(endTime % 100 == 0){ //0
                    //30
                    endTime += 30;
                    //1Ԍ炷
                    endTime -= 100;
                }
            }
        }
    }
	
	String getStartHour() {
		int h = startTime / 100;
		return "" + (h / 10) + (h % 10);
	}
	
	String getStartMinute() {
		int m = startTime % 100;
		return "" + (m / 10) + (m % 10);
	}
	
	String getEndHour() {
		int h = endTime / 100;
		return "" + (h / 10) + (h % 10);
	}
	
	String getEndMinute() {
		int m = endTime % 100;
		return "" + (m / 10) + (m % 10);
	}

    public void setEndTime(int endTime) {
        this.endTime = endTime;
    }

    public void setStartTime(int startTime) {
        if(startTime > 2230){
            this.startTime = 900;
        }else{
            this.startTime = startTime;
        }
    }
	
    boolean isAlldaySchedule(){
        if(startTime == 900 && endTime == 2300){
            return true;
        }else{
            return false;
        }
    }
}
