<?php

require_once("../sys_config.php");


class DaylyCalendarFactory{

  var $year;
  var $month;
  var $date;
  var $schedule;

  function DaylyCalendarFactory($year,$month,$date){
    settype($year,"string");
    settype($month,"string");
    settype($date,"string");
    $this->year = $year;
    $this->month = $month;
    $this->date = $date;
    $this->schedule = new MonthlyScheduleManager($year,$month);
  }

  function draw(){
    print "┌───┬───┐<br>\n";

    for($term = 1; $term <= MAX_TERM + 1; $term++){
      $time = 9 + intval(($term / 2));
      $timeline = false;

      if($term % 2 == 1){
        if($time < 10){
          print "│　";
        }else{
          print "｜ ";
        }

        print $time.":00├";
        
        $timeline = true;
      }else{
        print "│　　　｜";
      }

      // 予約か予定が入っているときマークをつける
      if($this->schedule->getProfile($this->date,$term) == "reserve" || $this->schedule->isReserveFinish($this->date,$term)){
        if($this->schedule->isReserveStart($this->date,$term)){
          print "　┳　";
        }else if($this->schedule->isReserveFinish($this->date,$term)){
          print "　┻　";
        }else{
          print "　┃　";
        }
      }else if($this->schedule->getProfile($this->date,$term) ==  "plan"){
        print "／／／";
      }else{
        print "　　　";
      }
      
      if($timeline){
        print "┤";
      }else{
        print "｜";
      }

      print "<br>\n";
    }

    print "└───┴───┘<br>\n";
  }
}
